<?php

require_once('../files/functions.php');

$user->IsAdmin();

function GetAction($action) {
	if(isset($_POST['action']) && $_POST['action'] == $action) {
		return true;
	} else {
		return false;
	}
}
/*
	Categories
*/

if(GetAction('get-category-details')) {
	$CategoryID = $layer->safe('CategoryID');

	$stmt = $pdo->prepare('SELECT * FROM categories WHERE CategoryID = :CategoryID');
	$stmt->execute(array(':CategoryID' => $CategoryID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();
		echo json_encode($row);
	}else{
	    echo "TEST";
    }
}

if(GetAction('save-category')) {
	$CategoryID = $layer->safe('EditCategoryID');
	$CategoryName = $layer->safe('EditCategoryName');
	$CategoryDescription = $layer->safe('EditCategoryDescription');
	$CategoryActive = $layer->safe('EditCategoryActive');

	$stmt = $pdo->prepare('SELECT * FROM categories WHERE CategoryID = :CategoryID');
	$stmt->execute(array(':CategoryID' => $CategoryID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('UPDATE categories SET CategoryName = :CategoryName, CategoryDescription = :CategoryDescription, CategoryActive = :CategoryActive WHERE CategoryID = :CategoryID');
		$stmt->execute(array(':CategoryName' => $CategoryName, ':CategoryDescription' => $CategoryDescription, ':CategoryActive' => $CategoryActive, ':CategoryID' => $CategoryID));
		echo "Категория успешно отредактирована";
	} else {
		echo 'Category does not exists.';
	}
}

if(GetAction('delete-category')) {
	$CategoryID = $layer->safe('EditCategoryID');

	$stmt = $pdo->prepare('SELECT * FROM categories WHERE CategoryID = :CategoryID');
	$stmt->execute(array(':CategoryID' => $CategoryID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM categories WHERE CategoryID = :CategoryID');
		$stmt->execute(array(':CategoryID' => $CategoryID));
	} else {
		echo 'Категории не существует.';
	}
}

if(GetAction('create-category')) {
	$CategoryName = $layer->safe('CategoryName');
	$CategoryDescription = $layer->safe('CategoryDescription');
	$CategoryActive = $layer->safe('CategoryActive');

	$stmt = $pdo->prepare('INSERT INTO categories (CategoryName, CategoryDescription, CategoryActive, CategoryDate) VALUES (:CategoryName, :CategoryDescription, :CategoryActive, :CategoryDate)');
	$stmt->execute(array(':CategoryName' => $CategoryName, ':CategoryDescription' => $CategoryDescription, ':CategoryActive' => $CategoryActive, ':CategoryDate' => time()));
    echo "Категория успешно создана";
}

/*
	Services
*/

if(GetAction('create-service')) {
	$ServiceName = $layer->safe('ServiceName');
	$ServiceDescription = $layer->safe('ServiceDescription');
	$ServiceCategoryID = $layer->safe('ServiceCategoryID');

	if(isset($_POST['ServiceAPI'])) {
		if(!filter_var($_POST['ServiceAPI'], FILTER_VALIDATE_URL) === false) {
			$ServiceAPI = $layer->safe('ServiceAPI');
		} else {
			echo 'Invalid service API URL.';
			exit();
		}
	}
	else
		$ServiceAPI = '';
	if(isset($_POST['ServiceOrderAPI'])) {
		if(!filter_var($_POST['ServiceOrderAPI'], FILTER_VALIDATE_URL) === false) {
			$ServiceOrderAPI = $layer->safe('ServiceOrderAPI');
		} else {
			echo 'Недопустимый URL-адрес API-адреса заказа.';
			exit();
		}
	} else
		$ServiceOrderAPI = '';

	$ServiceType = $layer->safe('ServiceType');
	$ServicePrice = $layer->safe('ServicePrice');
	$ServiceMinQuantity = $layer->safe('ServiceMinQuantity');
	$ServiceMaxQuantity = $layer->safe('ServiceMaxQuantity');
	$ServiceResellerPrice = $layer->safe('ServiceResellerPrice');
	$ServiceActive = $layer->safe('ServiceActive');

	if($ServiceMinQuantity < $ServiceMaxQuantity) {
		$stmt = $pdo->prepare('INSERT INTO services (ServiceName, ServiceDescription, ServiceCategoryID, ServiceAPI, ServiceOrderAPI, ServiceType, ServicePrice,
		ServiceMinQuantity, ServiceMaxQuantity, ServiceResellerPrice, ServiceActive, ServiceDate)
		VALUES (:ServiceName, :ServiceDescription, :ServiceCategoryID, :ServiceAPI, :ServiceOrderAPI, :ServiceType, :ServicePrice,
		:ServiceMinQuantity, :ServiceMaxQuantity, :ServiceResellerPrice, :ServiceActive, :ServiceDate)');

		$stmt->execute(array(':ServiceName' => $ServiceName, ':ServiceDescription' => $ServiceDescription, ':ServiceCategoryID' => $ServiceCategoryID, ':ServiceAPI' => $ServiceAPI,
		':ServiceOrderAPI' => $ServiceOrderAPI, ':ServiceType' => $ServiceType, ':ServicePrice' => $ServicePrice,
		':ServiceMinQuantity' => $ServiceMinQuantity, ':ServiceMaxQuantity' => $ServiceMaxQuantity, ':ServiceResellerPrice' => $ServiceResellerPrice, ':ServiceActive' => $ServiceActive,
		':ServiceDate' => time()));

        echo "Услуга успешно создана";
	} else {
		echo 'Минимальный уровень обслуживания не может превышать максимальное количество.';
	}
}

if(GetAction('get-service-details')) {
	$ServiceID = $layer->safe('ServiceID');

	$stmt = $pdo->prepare('SELECT * FROM services WHERE ServiceID = :ServiceID');
	$stmt->execute(array(':ServiceID' => $ServiceID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();

		$ServiceCategoryName = $layer->GetData('categories', 'CategoryName', 'CategoryID', $row['ServiceCategoryID']);
		$row['ServiceCategoryName'] = $ServiceCategoryName;
		echo json_encode($row);
	}
}

if(GetAction('save-service')) {
	$ServiceID = $layer->safe('EditServiceID');
	$ServiceName = $layer->safe('EditServiceName');
	$ServiceDescription = $layer->safe('EditServiceDescription');
	$ServiceCategoryID = $layer->safe('EditServiceCategoryID');

	if(isset($_POST['EditServiceAPI']) && !empty($_POST['EditServiceAPI'])) {
		if (!filter_var($_POST['EditServiceAPI'], FILTER_VALIDATE_URL) === false) {
			$ServiceAPI = $layer->safe('EditServiceAPI');
		} else {
			echo 'Недопустимый URL-адрес API-службы.';
			exit();
		}
	}
	else
		$ServiceAPI = '';

	if(isset($_POST['EditServiceOrderAPI']) && !empty($_POST['EditServiceOrderAPI'])) {
		if(!filter_var($_POST['EditServiceOrderAPI'], FILTER_VALIDATE_URL) === false) {
			$ServiceOrderAPI = $layer->safe('EditServiceOrderAPI');
		} else {
			echo 'Недопустимый URL-адрес API-адреса заказа.';
			exit();
		}
	} else
		$ServiceOrderAPI = '';

	$ServiceType = $layer->safe('EditServiceType');
	$ServicePrice = $layer->safe('EditServicePrice');
	$ServiceMinQuantity = $layer->safe('EditServiceMinQuantity');
	$ServiceMaxQuantity = $layer->safe('EditServiceMaxQuantity');
	$ServiceResellerPrice = $layer->safe('EditServiceResellerPrice');
	$ServiceActive = $layer->safe('EditServiceActive');

	if($ServiceMinQuantity < $ServiceMaxQuantity) {
		$stmt = $pdo->prepare('UPDATE services SET ServiceName = :ServiceName, ServiceDescription = :ServiceDescription, ServiceCategoryID = :ServiceCategoryID,
		ServiceAPI = :ServiceAPI, ServiceOrderAPI = :ServiceOrderAPI, ServiceType = :ServiceType, ServicePrice = :ServicePrice, ServiceMinQuantity = :ServiceMinQuantity,
		ServiceMaxQuantity = :ServiceMaxQuantity, ServiceResellerPrice = :ServiceResellerPrice, ServiceActive = :ServiceActive WHERE ServiceID = :ServiceID');

		$stmt->execute(array(':ServiceName' => $ServiceName, ':ServiceDescription' => $ServiceDescription, ':ServiceCategoryID' => $ServiceCategoryID, ':ServiceAPI' => $ServiceAPI,
		':ServiceOrderAPI' => $ServiceOrderAPI, ':ServiceType' => $ServiceType, ':ServicePrice' => $ServicePrice,
		':ServiceMinQuantity' => $ServiceMinQuantity, ':ServiceMaxQuantity' => $ServiceMaxQuantity, ':ServiceResellerPrice' => $ServiceResellerPrice, ':ServiceActive' => $ServiceActive,
		':ServiceID' => $ServiceID));
	} else {
		echo 'Минимальный уровень обслуживания не может превышать максимальное количество.';
	}
    echo "Услуга успешно отредактирована";
}

if(GetAction('delete-service')) {
	$ServiceID = $layer->safe('EditServiceID');

	$stmt = $pdo->prepare('SELECT * FROM services WHERE ServiceID = :ServiceID');
	$stmt->execute(array(':ServiceID' => $ServiceID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM services WHERE ServiceID = :ServiceID');
		$stmt->execute(array(':ServiceID' => $ServiceID));
	} else {
		echo 'Служба не существует.';
	}
}


// User


if(GetAction('get-user-details')) {
	$UserID = $layer->safe('UserID');

	$stmt = $pdo->prepare('SELECT * FROM users WHERE UserID = :UserID');
	$stmt->execute(array(':UserID' => $UserID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();
		echo json_encode($row);
	}
}

if(GetAction('save-user')) {
	$UserID = $layer->safe('EditUserID');
	$UserName = $layer->safe('EditUserName');
	$UserEmail = $layer->safe('EditUserEmail');
	$UserGroup = $layer->safe('EditUserGroup');
	$UserAPI = $layer->safe('EditUserAPI');
	$UserBalance = $layer->safe('EditUserBalance');

	if($settings['RequireUserFirstName'] == 'Yes') {
		$UserFirstName = $layer->safe('EditUserFirstName');
	} else {
		$UserFirstName = '';
	}

	if($settings['RequireUserLastName'] == 'Yes') {
		$UserLastName = $layer->safe('EditUserLastName');
	} else {
		$UserLastName = '';
	}

	if($settings['RequireUserSkypeID'] == 'Yes') {
		$UserSkypeID = $layer->safe('EditUserSkypeID');
	} else {
		$UserSkypeID = '';
	}

	if(!filter_var($UserEmail, FILTER_VALIDATE_EMAIL) === false) {
		$stmt = $pdo->prepare('SELECT * FROM users WHERE UserName = :UserName OR UserEmail = :UserEmail');
		$stmt->execute(array(':UserName' => $UserName, ':UserEmail' => $UserEmail));

		$UserCheckRow = $stmt->fetch();

		if($stmt->rowCount() == 0 || $stmt->rowCount() == 1) {
			$stmt = $pdo->prepare('UPDATE users SET UserName = :UserName, UserEmail = :UserEmail, UserGroup = :UserGroup, UserAPI = :UserAPI, UserBalance = :UserBalance,
			UserFirstName = :UserFirstName, UserLastName = :UserLastName, UserSkypeID = :UserSkypeID WHERE UserID = :UserID');

			$stmt->execute(array(':UserName' => $UserName, ':UserEmail' => $UserEmail, ':UserGroup' => $UserGroup, ':UserAPI' => $UserAPI, ':UserBalance' => $UserBalance,
			':UserFirstName' => $UserFirstName, ':UserLastName' => $UserLastName, ':UserSkypeID' => $UserSkypeID, ':UserID' => $UserID));
			echo 'Сохранено.';
		} else {
			echo 'Сохранено.';
		}
	} else {
		echo 'Неверный адрес электронной почты.';
	}
}

if(GetAction('ban-user')) {
	$UserID = $layer->safe('EditUserID');
	$ExpireDate = strtotime($layer->safe('EditUserBanExpireDate'));
	$Reason = $layer->safe('EditUserBanReason');
	if($ExpireDate > time()) {
		$stmt = $pdo->prepare('SELECT UserBannedID FROM users_banned WHERE UserBannedID = :UserBannedID');
		$stmt->execute(array(':UserBannedID' => $UserID));

		if($stmt->rowCount() == 0) {
			$stmt = $pdo->prepare('INSERT INTO users_banned (UserBannedID, UserBannedDate, UserBannedExpireDate, UserBannedReason) VALUES
			(:UserBannedID, :UserBannedDate, :UserBannedExpireDate, :UserBannedReason)');

			$stmt->execute(array(':UserBannedID' => $UserID, ':UserBannedDate' => time(), ':UserBannedExpireDate' => $ExpireDate, ':UserBannedReason' => $Reason));
		} else {
			echo 'Пользователь уже заблокирован.';
		}
	} else {
		echo 'Срок действия не может быть до этого момента.';
	}
}

if(GetAction('unban-user')) {
	$UserID = $layer->safe('UserID');

	$stmt = $pdo->prepare('SELECT * FROM users_banned WHERE UserBannedID = :UserBannedID');
	$stmt->execute(array(':UserBannedID' => $UserID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM users_banned WHERE UserBannedID = :UserBannedID');
		$stmt->execute(array(':UserBannedID' => $UserID));
	} else {
		echo 'Пользователь не существует или он не запрещен.';
	}
}

if(GetAction('create-user')) {
	$username = $layer->safe('UserName');
	$email = $layer->safe('UserEmail');
	$password = $layer->safe('UserPassword');
	$re_password = $layer->safe('UserRetypePassword');

	if($password == $re_password) {
		if(!filter_var($email, FILTER_VALIDATE_EMAIL) === false) {
			if(strlen($email) >= 4 && strlen($email) <= 48) {
				if(strlen($username) >= 4 && strlen($username) <= 32) {
					if(strlen($password) >= 4 && strlen($password) <= 32) {
						if($username != $password) {
							$stmt = $pdo->prepare('SELECT * FROM users WHERE UserName = :UserName OR UserEmail = :UserEmail');
							$stmt->execute(array(':UserName' => $username, ':UserEmail' => $email));

							if($stmt->rowCount() == 0) {
								if($settings['RequireUserFirstName'] == 'Yes') {
									$first_name = $layer->safe('UserFirstName');
									if(strlen($first_name) < 2 && strlen($first_name) > 16) {
										echo 'Длина имени должна быть от 2 до 16 символов.';
										exit();
									}
								} else {
									$first_name = '';
								}

								if($settings['RequireUserLastName'] == 'Yes') {
									$last_name = $layer->safe('UserLastName');
									if(strlen($last_name) < 2 && strlen($last_name) > 16) {
										echo 'Длина имени должна быть от 2 до 16 символов.';
										exit();
									}
								} else {
									$last_name = '';
								}

								if($settings['RequireUserSkypeID'] == 'Yes') {
									$skype_id = $layer->safe('UserSkypeID');
									if(strlen($skype_id) < 2 && strlen($skype_id) > 32) {
										echo 'Длина Skype должна быть от 2 до 32 символов.';
										exit();
									}
								} else {
									$skype_id = '';
								}

								$password = md5($password);
								$group = $layer->safe('UserGroup');
								$api = $layer->safe('UserAPI');
								$balance = $layer->safe('UserBalance');

								$stmt = $pdo->prepare('INSERT INTO users (UserName, UserPassword, UserEmail, UserGroup, UserAPI, UserBalance, UserDate, UserIPAddress, UserFirstName, UserLastName, UserSkypeID)
								VALUES (:UserName, :UserPassword, :UserEmail, :UserGroup, :UserAPI, :UserBalance, :UserDate, :UserIPAddress, :UserFirstName, :UserLastName, :UserSkypeID)');

								$stmt->execute(array(':UserName' => $username, ':UserPassword' => $password, ':UserEmail' => $email, ':UserGroup' => $group,
								':UserAPI' => $api, ':UserBalance' => $balance, ':UserDate' => time(), ':UserIPAddress' => $ip, ':UserFirstName' => $first_name, ':UserLastName' => $last_name, ':UserSkypeID' => $skype_id));
								echo 'Пользователь создан.';

							} else {
								echo 'Учетная запись с этим именем пользователя / адресом электронной почты уже зарегистрирована.';
							}
						} else {
							echo 'Пароль не может совпадать с именем пользователя.';
						}
					} else {
						echo 'Длина пароля должна быть между 32 символами.';
					}
				} else {
					echo 'Длина имени пользователя должна быть от 4 до 32 символов.';
				}
			} else {
				echo 'Длина электронной почты должна составлять от 4 до 48 символов.';
			}
		} else {
			echo 'Недействительный адрес электронной почты. Предоставьте рабочий.';
		}
	} else {
		echo 'Ваш повторно введенный пароль не соответствует первому.';
	}
}

if(GetAction('delete-user')) {
	$UserID = $layer->safe('EditUserID');

	$stmt = $pdo->prepare('SELECT UserID FROM users WHERE UserID = :UserID');
	$stmt->execute(array(':UserID' => $UserID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM users WHERE UserID = :UserID');
		$stmt->execute(array(':UserID' => $UserID));
	} else {
		echo 'Пользователь не существует.';
	}
}

// News

if(GetAction('add-news')) {
	$NewsTitle = $layer->safe('NewTitle');
	$NewsContent = $_POST['NewContent'];

	if(isset($_POST['NewIcon']) && !empty($_POST['NewIcon']))
		$NewsIcon = $layer->safe('NewIcon');
	else
		$NewsIcon = '';

	$stmt = $pdo->prepare('INSERT INTO news (NewTitle, NewContent, NewUserID, NewIcon, NewDate) VALUES (:NewTitle, :NewContent, :NewUserID, :NewIcon, :NewDate)');
	$stmt->execute(array(':NewTitle' => $NewsTitle, ':NewContent' => $NewsContent, ':NewUserID' => $UserID, ':NewIcon' => $NewsIcon, ':NewDate' => time()));
}

if(GetAction('get-news-details')) {
	$NewsID = $layer->safe('NewsID');

	$stmt = $pdo->prepare('SELECT * FROM news WHERE NewID = :NewID');
	$stmt->execute(array(':NewID' => $NewsID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();
		echo json_encode($row);
	}
}

if(GetAction('save-news')) {
	$NewID = $layer->safe('EditNewID');
	$NewsTitle = $layer->safe('EditNewTitle');
	$NewsContent = $_POST['EditNewContent'];

	if(isset($_POST['EditNewIcon']) && !empty($_POST['EditNewIcon']))
		$NewsIcon = $layer->safe('EditNewIcon');
	else
		$NewsIcon = '';

	$stmt = $pdo->prepare('UPDATE news SET NewTitle = :NewTitle, NewContent = :NewContent, NewIcon = :NewIcon WHERE NewID = :NewID');
	$stmt->execute(array(':NewTitle' => $NewsTitle, ':NewContent' => $NewsContent, ':NewIcon' => $NewsIcon, ':NewID' => $NewID));
}

if(GetAction('delete-news')) {
	$NewID = $layer->safe('EditNewID');

	$stmt = $pdo->prepare('SELECT NewID FROM news WHERE NewID = :NewID');
	$stmt->execute(array(':NewID' => $NewID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM news WHERE NewID = :NewID');
		$stmt->execute(array(':NewID' => $NewID));
	} else {
		echo 'Новости не существует.';
	}
}

// Individual Prices (IP)

if(GetAction('add-ip')) {
	$IPUserName = $layer->safe('IPUserName');

	$stmt = $pdo->prepare('SELECT UserID FROM users WHERE UserName = :UserName OR UserEmail = :UserEmail');
	$stmt->execute(array(':UserName' => $IPUserName, ':UserEmail' => $IPUserName));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();

		$IPUserID = $row['UserID'];
		$IPServiceID = $layer->safe('IPServiceID');

		$stmt = $pdo->prepare('SELECT ServiceID FROM services WHERE ServiceID = :ServiceID');
		$stmt->execute(array(':ServiceID' => $IPServiceID));

		if($stmt->rowCount() == 1) {
			$IPPrice = $layer->safe('IPPrice');

			$stmt = $pdo->prepare('INSERT INTO individual_prices (IPUserID, IPServiceID, IPPrice, IPDate) VALUES (:IPUserID, :IPServiceID, :IPPrice, :IPDate)');
			$stmt->execute(array(':IPUserID' => $IPUserID, ':IPServiceID' => $IPServiceID, ':IPPrice' => $IPPrice, ':IPDate' => time()));
		} else {
			echo 'Идентификатор службы не существует.';
		}
	} else {
		echo 'Пользователя не существует.';
	}
}

if(GetAction('get-ip-details')) {
	$IPID = $layer->safe('IPID');

	$stmt = $pdo->prepare('SELECT * FROM individual_prices WHERE IPID = :IPID');
	$stmt->execute(array(':IPID' => $IPID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();
		$IPUserName = $layer->GetData('users', 'UserName', 'UserID', $row['IPUserID']);
		$IPServiceName = $layer->GetData('services', 'ServiceName', 'ServiceID', $row['IPServiceID']);

		$row['IPUserName'] = $IPUserName;
		$row['IPServiceName'] = $IPServiceName;

		echo json_encode($row);
	} else {
		echo 'Индивидуальной цены не существует.';
	}
}

if(GetAction('save-ip')) {
	$IPID = $layer->safe('EditIPID');

	$stmt = $pdo->prepare('SELECT IPID FROM individual_prices WHERE IPID = :IPID');
	$stmt->execute(array(':IPID' => $IPID));

	if($stmt->rowCount() == 1) {
		$IPUserName = $layer->safe('EditIPUserID');

		$stmt = $pdo->prepare('SELECT UserID FROM users WHERE UserName = :UserName OR UserEmail = :UserEmail');
		$stmt->execute(array(':UserName' => $IPUserName, ':UserEmail' => $IPUserName));

		if($stmt->rowCount() == 1) {
			$row = $stmt->fetch();

			$IPUserID = $row['UserID'];
			$IPServiceID = $layer->safe('EditIPServiceID');
			$IPPrice = $layer->safe('EditIPPrice');

			$stmt = $pdo->prepare('UPDATE individual_prices SET IPUserID = :IPUserID, IPServiceID = :IPServiceID, IPPrice = :IPPrice WHERE IPID = :IPID');
			$stmt->execute(array(':IPUserID' => $IPUserID, ':IPServiceID' => $IPServiceID, ':IPPrice' => $IPPrice, ':IPID' => $IPID));
		} else {
			echo 'Пользователя не существует.';
		}
	} else {
		echo 'Индивидуальной цены не существует.';
	}
}

if(GetAction('delete-ip')) {
	$IPID = $layer->safe('EditIPID');

	$stmt = $pdo->prepare('SELECT IPID FROM individual_prices WHERE IPID = :IPID');
	$stmt->execute(array(':IPID' => $IPID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM individual_prices WHERE IPID = :IPID');
		$stmt->execute(array(':IPID' => $IPID));
	} else {
		echo 'Индивидуальной цены не существует.';
	}
}

// Deposits

if(GetAction('delete-deposit')) {
	$DepositID = $layer->safe('DepositID');

	$stmt = $pdo->prepare('SELECT DepositID FROM deposits WHERE DepositID = :DepositID');
	$stmt->execute(array(':DepositID' => $DepositID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM deposits WHERE DepositID = :DepositID');
		$stmt->execute(array(':DepositID' => $DepositID));
	} else {
		echo 'Депозита не существует.';
	}
}

if(GetAction('update-deposit')) {
	$DepositID = $layer->safe('DepositID');
	$DepositRefunded = $layer->safe('DepositRefunded');

	$stmt = $pdo->prepare('SELECT DepositID, DepositUserID, DepositAmount, DepositRefunded FROM deposits WHERE DepositID = :DepositID');
	$stmt->execute(array(':DepositID' => $DepositID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();

		$stmt = $pdo->prepare('UPDATE deposits SET DepositRefunded = :DepositRefunded WHERE DepositID = :DepositID');
		$stmt->execute(array(':DepositRefunded' => $DepositRefunded, ':DepositID' => $DepositID));

		$stmt = $pdo->prepare('SELECT UserBalance FROM users WHERE UserID = :UserID');
		$stmt->execute(array(':UserID' => $row['DepositUserID']));

		$query = $stmt->fetch();

		if($DepositRefunded == 'Yes') {
			if($row['DepositRefunded'] == 'No') {
				$stmt = $pdo->prepare('UPDATE users SET UserBalance = :UserBalance WHERE UserID = :UserID');
				$stmt->execute(array(':UserBalance' => $query['UserBalance'] - $row['DepositAmount'], ':UserID' => $row['DepositUserID']));
			}
		} else {
			if($row['DepositRefunded'] == 'Yes') {
				$stmt = $pdo->prepare('UPDATE users SET UserBalance = :UserBalance WHERE UserID = :UserID');
				$stmt->execute(array(':UserBalance' => $query['UserBalance'] + $row['DepositAmount'], ':UserID' => $row['DepositUserID']));
			}
		}
	} else {
		echo 'Депозита не существует.';
	}
}

// Frequently Asked Questions (FAQ)

if(GetAction('add-faq')) {
	$FAQQuestion = $layer->safe('FAQQuestion');
	$FAQAnswer = $layer->safe('FAQAnswer');

	$stmt = $pdo->prepare('INSERT INTO faq (FAQQuestion, FAQAnswer, FAQDate) VALUES (:FAQQuestion, :FAQAnswer, :FAQDate)');
	$stmt->execute(array(':FAQQuestion' => $FAQQuestion, ':FAQAnswer' => $FAQAnswer, ':FAQDate' => time()));
	echo "FAQ успешно добавлен";
}

if(GetAction('get-faq-details')) {
	$FAQID = $layer->safe('FAQID');

	$stmt = $pdo->prepare('SELECT * FROM faq WHERE FAQID = :FAQID');
	$stmt->execute(array(':FAQID' => $FAQID));

	if($stmt->rowCount() == 1) {
		$row = $stmt->fetch();
		echo json_encode($row);
	} else {
		echo 'FAQ не существует';
	}
}

if(GetAction('save-faq')) {
	$FAQID = $layer->safe('EditFAQID');

	$stmt = $pdo->prepare('SELECT FAQID FROM faq WHERE FAQID = :FAQID');
	$stmt->execute(array(':FAQID' => $FAQID));

	if($stmt->rowCount() == 1) {
		$FAQQuestion = $layer->safe('EditFAQQuestion');
		$FAQAnswer = $layer->safe('EditFAQAnswer');

		$stmt = $pdo->prepare('UPDATE faq SET FAQQuestion = :FAQQuestion, FAQAnswer = :FAQAnswer WHERE FAQID = :FAQID');
		$stmt->execute(array(':FAQQuestion' => $FAQQuestion, ':FAQAnswer' => $FAQAnswer, ':FAQID' => $FAQID));
		echo "FAQ успешно сохранен";
	} else {
		echo 'FAQ не существует';
	}
}

if(GetAction('delete-faq')) {
	$FAQID = $layer->safe('EditFAQID');

	$stmt = $pdo->prepare('SELECT FAQID FROM faq WHERE FAQID = :FAQID');
	$stmt->execute(array(':FAQID' => $FAQID));

	if($stmt->rowCount() == 1) {
		$stmt = $pdo->prepare('DELETE FROM faq WHERE FAQID = :FAQID');
		$stmt->execute(array(':FAQID' => $FAQID));
	} else {
		echo 'FAQ не существует';
	}
}
